// auteur: JCC
// modifs: RB

#include <iostream>
#include <string>
#include <vector>
using namespace std;

// =============================================================
//
// Comment compléter la structure Personne pour y montrer 
//                  l'ensemble des amis de cette Personne :
//

// prédéclaration
struct Personne;

// le lien vers un(e) ami(e) est une adresse de Personne
// mémorisée à l'aide d'un pointeur Personne*
// On ajoute const pour autoriser l'accès en lecture seulement
typedef vector<const Personne*> Liste_Personnes;

struct Personne
{
  string nom;
  Liste_Personnes amis;
};

int main()
{
  Personne alice = {"Alice", {}};
  Personne bob   = {"Bob",   {}};
  Personne claire= {"Claire",{}};
  
  alice.amis.push_back(&bob);
  alice.amis.push_back(&claire);
  
  for(auto x : alice.amis)
		cout << x->nom << endl;
  
  return 0;
}
