#include <iostream>
#include <memory>
#include <vector>
#include <string>
using namespace std;

struct  Personne;
typedef vector<const Personne*> Liste_Personnes;

struct Personne
{
  string nom;
  Liste_Personnes amis;
};

void f();
Personne* g();

int main()
{
	cout << "Appel de f()" << endl;
	f();
	cout << "retour dans main()" <<endl;
	
	return 0;
}

void f()
{
	Personne* pt(nullptr);

	cout << "Appel de g()" << endl;
	pt = g();
	cout << "retour dans f()" <<endl;
	
	if(pt)
		cout << " f() viens de recevoir :" << pt->nom << endl;
	
	//Ne pas oublier de libérer l'espace alloué dynamiquement
	delete pt;
	
    cout << "fin de f()" << endl;
}
	
Personne* g()
{
	Personne* local_pt(nullptr);
	
	// renvoie nullptr en cas d'échec
	local_pt = new (nothrow) Personne({"Albert",{}}); 

	cout << "Bonjour, Je m'appelle " << local_pt->nom << endl;
	
	return local_pt;
}
